Name:		uln-yum-mirror
Version:	0.3.0
Release:	10%{?dist}
Summary:	Setup a local yum mirror from the Unbreakable Linux Network

Group:		System Environment/Base
License:	GPL
Vendor:         Oracle USA
URL:		http://linux.oracle.com/
Source0:	%{name}-%{version}.tar.gz
Patch0:		uln-yum-mirror-0.3.0-9-to-uln-yum-mirror-0.3.0-10.patch
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildArch:	noarch

Obsoletes:      uln-yum-proxy
Requires:       hardlinkpy
Requires:       httpd
Requires:       python-urlgrabber
Requires:	yum
Requires:	yum-rhn-plugin
Requires:	yum-arch

%if 0%{?rhel} >= 6
Requires:       createrepo >= 0.9.9-17.0.1
Requires:       yum-utils >= 1.1.30-6
%else
Requires:       createrepo
Requires:       yum-utils >= 1.1.16-21.0.1
%endif


%description
Creates a local yum mirror from subscribed Unbreakable Linux Network channels. 

%prep
%setup -q
%patch0 -p1

%build

%install
rm -rf %{buildroot}
install -D %{name} %{buildroot}%{_bindir}/%{name}
install -D %{name}.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/%{name}
install -D %{name}.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -D %{name}.cron %{buildroot}%{_sysconfdir}/cron.daily/%{name}
install -D RPM-GPG-KEY-oracle-el4 %{buildroot}%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-el4
install -D RPM-GPG-KEY-oracle-ol5 %{buildroot}%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol5
install -D RPM-GPG-KEY-oracle-ol6 %{buildroot}%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol6
install -D RPM-GPG-KEY-oracle-ol8 %{buildroot}%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol8
install -D COPYING %{buildroot}/COPYING
install -D README.html %{buildroot}/README.html
install -D README %{buildroot}/README
install -D -d %{buildroot}%{_localstatedir}/log
touch %{buildroot}%{_localstatedir}/log/%{name}.log

%clean
rm -rf %{buildroot}

%post
# Install EL4 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-b38a8516-44fd79eb >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-el4
# Install EL5 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-1e5e0159-464d0428 >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol5
# Install OL6/OL7 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-ec551f03-53619141 >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol6
# Install OL8 RPM-GPG-KEY if needed
rpm -q gpg-pubkey-ad986da3-5cabf60d >/dev/null 2>&1 || \
  rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol8

%files
%defattr(644, root, root)
%doc /COPYING
%doc /README.html
%doc /README
%config(noreplace) %{_sysconfdir}/sysconfig/uln-yum-mirror
%attr(755, root, root) %{_bindir}/uln-yum-mirror
%attr(755, root, root) %{_sysconfdir}/cron.daily/uln-yum-mirror
%{_sysconfdir}/logrotate.d/uln-yum-mirror
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-el4
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol5
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol6
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-oracle-ol8
%ghost %{_localstatedir}/log/uln-yum-mirror.log

%changelog
* Thu Nov 17 2022 Ameya Bhalerao <ameya.b.bhalerao@oracle.com> - 0.3.0-10
- Reinitialising MODULESYAMLFILE variable in uln-yum-mirror to resolve customer issues [Orabug: 34808808]
- Changed patching method (now using tarball and separate patches; used direct source patching before)
- Reviewed-by: Laurence Rochfort <laurence.rochfort@oracle.com>

* Wed Jul 6 2022 Ameya Bhalerao <ameya.b.bhalerao@oracle.com> - 0.3.0-9
- Update to mirror PCA channels under lowercase directory name [Orabug: 34284702]

* Wed Jan  19 2022 PSM Swamiji <psm.swamiji@oracle.com> - 0.3.0-8
- Support PCA channels to mirror under EngineeredSystems directory [Orabug: 33767547]

* Thu Aug  5 2021 Todd Vierling <todd.vierling@oracle.com> - 0.3.0-7
- use the non-gzipped comps.xml group file [Orabug: 33194673]

* Thu Jun 24 2021 Todd Vierling <todd.vierling@oracle.com> - 0.3.0-6
- ignore ALL_PKGS=0 for modular yum repositories [Orabug: 32969364]

* Mon Jul 29 2019 Jared Greenwald <jared.greenwald@oracle.com> - 0.3.0-5
- Handle unique metadata files [Orabug: 29962823]
- Update for OL8

* Mon Oct 16 2017 Jared Greenwald <jared.greenwald@oracle.com> - 0.3.0-4
- Append to log when run from cron

* Wed Jun  7 2017 Leon Wang <leon.w.wang@oracle.com> - 0.3.0-3
- Bug 26121876 add uln-yum-mirror locking mechanism

* Tue Jan 26 2016 Jared Greenwald <jared.greenwald@oracle.com> - 0.3.0-2
- Fix directory naming for Oracle VM 3.3 channels [orabug 22599619]

* Wed Jun 25 2014 Avi Miller <avi.miller@oracle.com> - 0.3.0-1
- Added support for Oracle Linux 7
- Modified the logic for creating local paths for repos to make them more readable

* Tue Apr 9 2014 Avi Miller <avi.miller@oracle.com> - 0.2.1-1
- Set createrepo and modifyrepo to use simple filenames [orabug 17608573]
- expose the EXTRA_ARGS in the sysconfig script

* Fri Feb 14 2014 Avi Miller <avi.miller@oracle.com> - 0.2.0-1
- Escape the disablerepo parameter for yum makecache
- Shift yum makecache to occur only on Oracle Linux 5

* Sat Feb 8 2014 Avi Miller <avi.miller@oracle.com> - 0.1.6-1
- Move ALL_PKGS logic so that it works on both OL5 and OL6 [orabug 18205425]

* Wed Jan 22 2014 Avi Miller <avi.miller@oracle.com> - 0.1.5-1
- Check physical memory and disable the "--update" parameter to createrepo if less than 6GB. This should avoid OOM-killer on large repos

* Fri Jan 10 2014 Avi Miller <avi.miller@oracle.com> - 0.1.4-2
- Set reposync to remove RPMs that fail GPG checking after downloading

* Fri Jan 10 2014 Avi Miller <avi.miller@oracle.com> - 0.1.4-1
- Set hardlinkpy to ensure filenames are identical
- Exclude cache and metadata directories from hardlinking to improve scanning performance
- Set yum-arch to quiet to reduce log output

* Mon Nov 25 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-4
- Fix incorrect path in logrotate script
- Set logrotate to compress uln-yum-mirror logs on a daily basis

* Tue Nov 19 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-3
- Switch license to GPL and add GPL license text
- Add README documentation

* Mon Nov 04 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-2
- Set minimum yum-utils version to ensure reposync --source support on Oracle Linux 5

* Fri Nov 01 2013 Avi Miller <avi.miller@oracle.com> - 0.1.3-1
- Remove check for uln-yum-proxy

* Thu Oct 10 2013 Avi Miller <avi.miller@oracle.com> - 0.1.1-1
- Obsolete uln-yum-proxy
- Add dependencies for syncing, creating and hosting yum repos from uln-yum-proxy
- Install RPM-GPG-KEY for EL4, OL5 and OL6
- Track logfile in RPM file list

* Tue Oct 08 2013 Avi Miller <avi.miller@oracle.com> - 0.0.11-1
- Add locking to cron script so that only one instance of uln-yum-mirror runs

* Wed Oct 02 2013 Avi Miller <avi.miller@oracle.com> - 0.0.10-1
- Added parameter to make hardlinkpy quieter when logging
- Remove support for running the script on OL4/EL4
- Check for rpm installation more effeciently
- Make reposync run quiet
- move hardlinking to after all the repos are downloaded

* Mon Sep 30 2013 Avi Miller <avi.miller@oracle.com> - 0.0.7-1
- Added hardlinkpy support to reduce storage requirements
- Added logging support and log rotation

* Thu Sep 19 2013 Avi Miller <avi.miller@oracle.com> - 0.0.4-1
- Added option to download all packages instead of just latest packages
- Added cronjob support

* Thu Nov 09 2006 Avi Miller <avi.miller@oracle.com> - 0.0.1-1
- Initial version
